/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.CategoriaCtrl;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderCategoriaDescuento;

/**
 * 
 * @author rodrigo
 */
@Controller("busquedaConfiguracionCategoriaController")
@Scope("prototype")
public class BusquedaConfiguracionCategoriaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<CategoriaCtrl> plwpagingcategoriaCtrl;
	private MyListbox categoriaCtrlList;
	private Paging pagingCategoriaCtrl;
	private Textbox txtNome;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		categoriaCtrlList.setItemRenderer(new RenderCategoriaDescuento());
		categoriaCtrlList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				CategoriaCtrl cc = (CategoriaCtrl) categoriaCtrlList.getSelected();
				verConfigCategoria(cc);
			}
		});

		refreshLista();

		txtNome.focus();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verConfigCategoria(CategoriaCtrl cc) {
		if (cc == null) {
			return;
		}

		Map args = new HashMap();
		args.put("categoriaCtrl", cc);
		args.put("categoriaCtrlList", categoriaCtrlList);

		openWindow("/gui/configuraciones_comerciales/editarConfiguracionCategorias.zul",
				Labels.getLabel("editarConfiguracionCategoriaController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<CategoriaCtrl> configCategoriaBusqueda =new HibernateSearchObject<CategoriaCtrl>(CategoriaCtrl.class,pagingCategoriaCtrl.getPageSize());

		if (!txtNome.getText().equals("")) {
			configCategoriaBusqueda.addFilterLike("empresa.nombempresa", "%" + txtNome.getText().trim().concat("%"));
		}

		configCategoriaBusqueda.addFilterEqual("empresa.activo", Boolean.TRUE);
		configCategoriaBusqueda.addFilterEqual("activo", Boolean.TRUE);
		configCategoriaBusqueda.addSortAsc("empresa.nombempresa");
		
		configCategoriaBusqueda.addFilterIn("empresa", UsuarioLogado.getUsuarioLogado().getEmpresa());
		

		plwpagingcategoriaCtrl.init(configCategoriaBusqueda, categoriaCtrlList, pagingCategoriaCtrl);

		if (categoriaCtrlList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaConfiguracionCategoriaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verConfigCategoria(new CategoriaCtrl());
	}
}
